
#include <allegro.h>
#include <iostream>
#include <vector>
#include <math.h>
#include <list>
#include <set>
#include <fstream>
#include <algorithm>
#ifdef __APPLE__
#include <ApplicationServices/ApplicationServices.h>
#endif
#include "random.hpp"
#include "map.txt"

using namespace std;
const float PI = 3.1415926535;
BITMAP* buffer;

#define DEFBMP(x,y,z) BITMAP* bmp_##x; const int bmp_w_##x=y; const int bmp_h_##x=z; const char* bmp_s_##x = "bmp/" #x ".bmp";
#define LOADBMP(x) bmp_##x = load_bmp(bmp_s_##x, NULL);
#define DRAWTILE(bmp,n,x,y) masked_blit(bmp_##bmp, buffer, n*bmp_w_##bmp, 0, x, y, bmp_w_##bmp, bmp_h_##bmp)
#define DRAWSPR(bmp,n,dir,x,y) dir ?\
	masked_blit(bmp_##bmp, buffer, (n)*bmp_w_##bmp, 0, (x)-bmp_w_##bmp/2, (y), bmp_w_##bmp, bmp_h_##bmp/2) :\
	masked_blit(bmp_##bmp, buffer, (n)*bmp_w_##bmp, bmp_h_##bmp/2, (x)-bmp_w_##bmp/2, (y), bmp_w_##bmp, bmp_h_##bmp/2);
				
int engagedwith;

DEFBMP(bar,66,20)
DEFBMP(icons,7,11)
DEFBMP(portraits,30,39)
DEFBMP(rooms,38,44)
DEFBMP(spritesheet,18,34)
DEFBMP(title,180,160)
DEFBMP(outline,180,160)
DEFBMP(visitors,13,22)

enum eBars {
	BAR_SLEEP=0,
	BAR_TOILET=2,
	BAR_FOOD=1,
	BAR_SOCIAL=3
};

bool disableactions;

int collapsetype;//0 food 1 sleep
bool noisebar[4];

int noSleepCount;

enum Person {
	P_Charles,
    P_OldLady,
    P_Doctor,
	P_Daughter,
	P_Nurse,
	P_YoungCharles,
	P_Hank,
	
};

int nurseconversation;

enum GameState {
    GS_InitPause,
    GS_Normal,
    GS_Cutscene,
    GS_WaitPreFlashBack,
    GS_FlashBack,
    GS_WaitPostFlashBack,
    GS_PreCollapse,
    GS_CollapseCutscene,
    GS_PostCollapse,
    GS_BedBound,
    GS_PreCutscene
} gamestate;

int collapsecount;
bool bDepressed;
bool bDruggedup;

bool bWetpants;

int flashbacknumber;//#2 is really the visit
struct CLine {
	Person person;
	string text;
	CLine(Person p, string t):person(p),text(t){};
};

#define say(x,s) conv.push_back(CLine(P_##x,s));

vector<int> roomplacement;

vector<CLine> curConversation;
unsigned int curConversationLine;

bool hadconversations[100];

int afteractiontimer;

bool hasfeedingtubealready;

int curconversationnumber;

vector<CLine> PopulateConversation(int c)
{
    curconversationnumber=c;
    curConversationLine=0;
	vector<CLine> conv;
	switch (c)
	{
		case 0:
			//intro
			say(Nurse,"Mr Palmer");
				
			say(Charles,"Please, call me Charles.");
			
			say(Nurse, "Welcome to Sunset Springs Charles, my name's Moira.");
				
			say(Charles,"Moira, what a beautiful name!");
				
			say(Charles,"It's a pleasure to meet you.");
            
			say(Nurse,"And I you.");
            
            say(Nurse,"I'm sure you'll settle down here in no time.");
				
			say(Charles,"It seems very nice here.");
			
			say(Nurse,"Let me know if there's anything you need.");
			
			say(Charles,"I will.");
				
			say(Charles,"Thank you.");

			say(Nurse,"Have a good day.");
            
			break;
		case 1:
			//[social desire]

			say(Charles,"Moira, hello");
			
			say(Nurse,"Hello Charles, how're you getting on?");
			
			say(Charles,"Oh I'm fine.")
            
            say(Charles, "Thought I'd see how you are doing.");
			
			say(Nurse,"Ah sure I'm fine, amn't I?");

            say(Nurse,"Have you been settling in?");
			
			say(Charles,"Yes, it's so nice here, so quiet.");
            
            say(Charles,"In the morning I can hear the trees.")
            
             say(Charles,"I can hear them rustling by my window.");
			
			say(Nurse,"Must be a change of pace from city life.");
			
			say(Charles,"Yes, but it's a nice change.");
            
            say(Charles,"I never had time to sit back.");
            
            say(Charles,"Never had time to think, back there.");
			
			say(Nurse,"You've been working your whole life.");
            
            say(Nurse,"You deserve a bit of a R&R, hah?");
			
			say(Charles,"Yes, I suppose I do..");
			
			say(Nurse,"Anyway, have a nice day.")
            
            say(Nurse,"Let me know if you need anything.");
			
			say(Charles,"Will do.  Good day to you.");
			
			say(Nurse,"Good day.");
			
			break;
		case 2:
			say(Charles,"Moira, hello.");
			
			say(Nurse,"Charles, my name's Maggie");
            
             say(Nurse,"Don't want to be mixing up womens' names like that, eh?");
			
			say(Charles,"Haha ah it's my old age, you'll have to excuse me.");  
			
			say(Nurse,"How're you getting on then?");
			
			say(Charles,"Oh it's so nice here, so quiet.");
            
            say(Charles,"In the morning  I can hear the trees outside.");
			
			say(Nurse,"Yes; it's ever so lovely this time of year.");
            
            say(Nurse, "I went out to the park last week with my family.");
			
			say(Charles,"Did you have a picnic?");
			
			say(Nurse,"Oh no; we went for a walk.");
				
			say(Charles,"Did the weather keep up for it?");
					
			say(Nurse,"Oh yes; I got a lovely tan.");
			
			say(Charles,"Did you bring the dog along?");
			
			say(Nurse,"Ah you're always asking after the dog.");
            
            say(Nurse,"We did.");
            
            say(Nurse,"Played fetch with her there.");
            
            say(Nurse,"Lovely time we had.");
			
			say(Charles,"Ah that's nice.");
			
			say(Charles,"It was good talking to you so, Maggie.");
			
			say(Nurse,"You too Charles; have a nice day.");
			
			break;
		case 3:
			//unfinished
			say(Charles,"Hello Catherine.");
			
			say(Nurse,"Ah Charles, how're we doing today?");
	
			say(Charles,"Ah I'm happy, you know:  Happy.");
			
			say(Nurse,"That's nice, Charles.");
			
			break;
		case 4:
			//[go to zero]
			//[sleep]
			say(Doctor,"Charles,");
            
            say(Doctor,"Martha found you sleeping in the hallway.");
			
			say(Charles,"Oh, I'm sorry...I was so tired...");
			
			say(Doctor,"You have to be more careful in future.");
			
			say(Charles,"I'm sorry,");
            
            say(Charles,"I don't know what came over me.");
 
            say(Doctor,"I'll prescribe you some sedatives.");
			
			say(Doctor,"They'll help you rest.");
            break;
            
		case 5:
			//[food]
			
			say(Nurse,"Charles, can you hear me?");
			
			say(Doctor,"Charles, you collapsed.");
            
            say(Nurse, "You hadn't been eating at all.");
			
			say(Charles,"I'm sorry...");
                        
            say(Doctor,"You got very sick.");
			
			say(Nurse,"I was ever so worried.");
            
            say(Nurse,"I had to call the doctor.");
			
            say(Charles,"I don't mean to worry you.");
            
            say(Nurse,"He decided to install a feeding tube. ");
			
            say(Charles,"I ...");
            
			say(Charles,"... I understand.");
            
            say(Charles,"I don't want to worry you. ");
			
			say(Doctor,"There's a good boy, Charles." );

			
			break;
		case 6:
			//[bathroom]

			say(Nurse,"Oh dear, Charles,");
            
            say(Nurse,"Looks like you've had an accident.");
			
			say(Charles,"I'm...I'm sorry...");
			
			say(Nurse,"No need to worry, Charles.");
            say(Nurse,"It happens to all of us eventually.");
            say(Nurse,"I'll get you some diapers.");
        
            say(Nurse,"You won't have to worry about having accidents.");
			
			say(Charles,"...diapers...");
			
			say(Nurse,"It's nothing to be ashamed of.");
            say(Nurse,"It'll make life a lot easier for you.");
				
			say(Charles,"...ok...");

				
			break;
		case 7:
			
//			...bar breaks down...;
			
			say(Nurse,"Charles, is everything all right?");
			
			say(Charles,"...");
			
			say(Nurse,"You've been awful quiet recently, haven't you?");
			
			say(Charles,"...");
			
			say(Nurse,"Ah well...");
			
			say(Charles,"...");
			
			break;
		case 8:
			//flashback dialogue
			
			say(YoungCharles,"Hank, you can't be serious?");
			
			say(Hank,"Charles, I have a wife and kid");
            
			say(Hank,"I love both of them with all my heart.");
			
			say(YoungCharles,"Hank, you can't mean that.");
			
			say(Hank,"Can't mean what?")
            
            say(Hank,"My place is with them.");
            
             say(Hank,"It's where I want to be.");
			
			say(Hank,"You know...");
            
            say(Hank,"You should get yourself a girl as well.");
			
			break;
		case 9:
			//flashback
			say(Daughter,"Hello dad!");
			
			say(Charles,"Jane, what're you doing here?");
			
            say(Charles,"You leave me here alone for all this time...");
            
            say(Charles,"And come waltzing in here now?");
            
			say(Daughter,"I come by every Monday.");
            
            say(Daughter,"I bring you fresh flowers.");
			
			say(Charles,"You ... bring me flowers?");
			
			say(Daughter,"We have a good chat, and I bring you flowers.");
            
			say(Daughter,"Every Monday.");
			
			say(Charles,"Oh ... that's very nice of you.");
			
			say(Daughter,"So, how are you feeling?");
			
			say(Charles,"I'm good.  It's lovely here.");
			
			say(Charles,"It's so nice here, so quiet.");
            
            say(Charles,"In the morning I can hear the trees.")
            
            say(Charles,"I can hear them rustling by my window.");
			
			say(Daughter,"I'm glad that you're happy.");            
            
            say(Charles,"I have everything that I could want.");            
            
            say(Charles,"I've never been happier.");
			            
			///CUT here fade to black then penultimate phase where you just press x to get attention?
			break;
		case 10:
			//final phase just have you in bed incapacitated with the nurse tending to your needs
			break;
        case 11://first time going to bed
            say(Charles,"Oh well; off to bed I go...");
            break;
        case 12://talk to nurse after depressed first time
            say(Nurse,"Charles, is everything okay?");
            say(Charles,"...");
            say(Nurse,"You've seemed so sad recently.");
            say(Charles,"...");
            say(Nurse,"I'll get you some anti-depressants.");
            say(Nurse,"They might help you feel better.");
            say(Charles,"...");
            break;
        case 13://talk to nurse after depressed
            say(Nurse,"Hello, Charles.");
            say(Charles,"...");
            break;
        case 14:
            say(Charles,"No, I don't want to.");
            break;
		}
	return conv;
	
}

float amounts[4];
float damounts[4];

int endtimer=0;
int gametimer;
int inittimer;
int engagedtimer;

int filteramount=2;//5000 max, say;

int magenta;
int red;
int lightred;
int black;
int white;
int green;
int lightgreen;
int orange;
int purp0;
int purp1;
int purp2;
int amber;
int grey;
int lightgrey;
int blue;
int yellow;
int bgcol;



void wrapprint( const string& str, int x, int y, int width=19 )
{
	
    if (width==0)
        return;
	
    string s=str+" ";
    int cury=y;
	unsigned int startp=0;
    while (startp<s.size())
    {
        unsigned int endp=startp+1;
        int lastspace=-1;
		
        while (endp<=width+startp)
        {
			
            if (endp==s.size())
            {
                lastspace=endp;
                break;
            }
            if (s[endp]=='\n')
            {
                lastspace=endp;
                break;
            }
            else if (s[endp]==' ')
            {
                lastspace=endp;
            }
            endp++;
        }
		
        if (lastspace>=0)//wrap a word around
        {
            //if two consecutive newlines
            if (s.substr(startp,lastspace-startp)=="\n")
            {
                startp=lastspace+1;
            }
            else
            {
				textout_ex(buffer, font, s.substr(startp,lastspace-startp).c_str(), x, cury, amber, -1);
                startp=lastspace+1;
            }
        }
        else //word bigger than line, just thunk
        {
			textout_ex(buffer, font, s.substr(startp,endp-startp).c_str(), x, cury, amber, -1);
            startp+=width;
        }
		
        cury+=10;
		
    }
}




/*
 
map

 101
 101
 101
 111
 
 
 
 */

int hasbeentosleep;

int brightness;
char itemcounttext[30];

const int TILE_WIDTH=11;
const int TILE_HEIGHT=14;

const int SCREEN_WIDTH=160;
const int SCREEN_HEIGHT=120;

const int endx=55; const int endy=8;



int itemcount=0;


bool spacepressed;


bool quit=false;


int algdone=false;

char leveltitle[200];

vector<int> bgs;


int levelseed;
const int TILE_SIZE=13;
const int MARGIN=10;
const int TRIANGLE_SIZE = 50;
const int ICON_RADIUS = 10;
const int FRAMERATE=5;
const int FONT_HEIGHT=8;
int bltime;
int endmenutimer;
bool endmode;

bool gameover;
uint musictimer;

bool dragmode;
uint curnote;

uint melody_length=10;
int level_code;

struct Pos{
	float x;
	float y;
	float a;
};
Pos pos;

const Pos lights[2] = 
{
{1.5,-1,0},
{3.5,-1,0}
};

bool deadly[46][61];

Pos target[2];
bool inbase[2];

Pos base[2];

const int CIRCLECOUNT=20;

Pos circles[CIRCLECOUNT];
Pos circelvels[CIRCLECOUNT];

//used for targetting numerical enemies

#include "sound.hpp"
#include "timer.hpp"

const int ts=13;
bool leave=false;
int titletimer=0;
bool finishedtitle;

bool escpressed;
bool apressed;

bool collided;

int leveltimer;

int levelgoal;

bool talkingToNurse;



bool stoppedfather;
bool upblock;



const int T1=35;
const int T2=25;

int killtimer=0;

bool drawbars=true;
bool drawdbox=true;

int px;
bool pdir;
int MIN_X=18;
int MAX_X=SCREEN_WIDTH-MIN_X;
bool walkmode=true;
bool canmove=true;
bool showbgs=true;
bool pressed[3];//left right space
bool ticking;
int lifetimer;
bool goingtosleep;
int lastcutscenetimer;
bool lastscenestarted;

int numnonnoisy;

class LevelLoop
	{
	public:
		static void initialize()
		{        
            disableactions=false;
            lastscenestarted=false;
            walkmode=true;
            canmove=true;
            showbgs=true;
            lastcutscenetimer=0;
            noSleepCount=true;
            bWetpants=false;
            talkingToNurse=true;
            nurseconversation=0;
            bDepressed=false;
            bDruggedup=false;
            hasbeentosleep=false;
            goingtosleep=false;
            afteractiontimer=0;
            flashbacknumber=1;
            collapsecount=0;
            numnonnoisy=4;
            
            for (int i=0;i<4;i++)
                noisebar[i]=false;
            
            //noisebar[1]=true;///JUST FOR TESTING
            
            spacepressed=true;
            
            for (int i=0;i<100;i++)
            {
                hadconversations[i]=false;
            }   
            
			engagedwith=-1;
			
			for (int i=0;i<4;i++)
			{
				amounts[i]=0.9f;
				damounts[i]=0.0006f;
			}
            
            gamestate=GS_InitPause;
            flashbacknumber=2;
            
            inittimer=5;
            
			gametimer=0;
			
			roomplacement.clear();
			
			px=18;
			pdir=false;
			itemcount=0;
			escpressed=true;
			quit=false;
			finishedtitle=false;
			pos.x=1.5;
			pos.y=1.5;
			pos.a=3*PI/2;
			playmusic(0);
			for (int i=0;i<3;i++)
				pressed[i]=true;
			
			bgs.clear();
			for (int i=0;i<4;i++)
			{
				bgs.push_back(3-i);
			}            		
		}
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		static void logic()
		{
            if (afteractiontimer>0)
                afteractiontimer--;
            
            numnonnoisy=0;
            for (int i=0;i<4;i++)
                if (!noisebar[i])
                    numnonnoisy++;
                    
            if (numnonnoisy==2)
            {
                for (int i=0;i<4;i++)
                {
                    damounts[i]=0.004f;
                }
            }
            if (gamestate==GS_Normal && numnonnoisy==0 && !lastscenestarted)
            {
                lastcutscenetimer++;
                if (lastcutscenetimer>40)
                {
                    gamestate=GS_WaitPreFlashBack;
                    inittimer=20;
                    playmusic(1);
                    lastscenestarted=true;
                }
            }
            
            if (inittimer>0)
            {
                inittimer--;
                if (inittimer==0)
                {
                    switch (gamestate)
                    {
                        case GS_InitPause:
//                        gamestate=GS_Normal;
                            gamestate=GS_Cutscene;
//                            gamestate=GS_WaitPreFlashBack;
                            inittimer=20;
                            curConversation=PopulateConversation(0);
                            break;            
                        case GS_WaitPreFlashBack:
                            gamestate=GS_FlashBack;
                            if (flashbacknumber==1)
                                curConversation=PopulateConversation(8);
                            else
                                curConversation=PopulateConversation(9);
                            break;
                        case GS_WaitPostFlashBack:
                        {
                            finishedtitle=true;
                        }
                        break;
                        case GS_PreCollapse:
                            if(collapsetype==0)
                            {
                                gamestate=GS_CollapseCutscene;
                                curConversation=PopulateConversation(5);
                                noisebar[1]=true;
                            }
                            else
                            {
                                gamestate=GS_CollapseCutscene;
                                curConversation=PopulateConversation(4);
                                noisebar[3]=true;
                            }                            
                            break;
                        case GS_PostCollapse:
                            {
                                if (noisebar[0]&&noisebar[1]&&noisebar[2]&&noisebar[3])
                                {
                                    gamestate=GS_CollapseCutscene;
                                }
                                else
                                    gamestate=GS_Normal;
                            }
                            break;
                        case GS_PreCutscene:
                            gamestate=GS_Cutscene;
                            curConversationLine=0;
                            break;
                    }
                }
            }
            
            if (gamestate==GS_Normal)
            {
                gametimer++;
                              
                for (int i=0;i<4;i++)
                {
                    if (!noisebar[i])
                    {
                        if (engagedwith!=i)
                        {
                            amounts[i]=max(amounts[i]-damounts[i],0.0f);
                            
                            if (amounts[i]<=0.000001f&&engagedwith==-1)
                            {
                                switch (i)
                                {
                                case 0:
                                    bDepressed=true;
                                    gamestate=GS_PreCutscene;                                    
                                    inittimer=4;
                                    curConversationLine=0;
                                    curConversation=PopulateConversation(12);
                                    return;
                                break;
                                case 1:
                                    gamestate = GS_PreCollapse;
                                    collapsetype=0;
                                    collapsecount++;
                                    inittimer=30;
                                    return;
                                break;
                                case 2:
                                    bWetpants=true;
                                    gamestate = GS_PreCutscene;
                                    curConversationLine=0;
                                    curConversation=PopulateConversation(6);
                                    inittimer=3;
                                    return;
                                break;
                                case 3:
                                    noSleepCount++;
                                    gamestate = GS_PreCollapse;
                                    collapsetype=1;
                                    inittimer = 30;
                                    return;
                                break;
                                }
                            }
                            
                        }
                        else
                        {
                            amounts[i]=max(amounts[i]+3*0.001f,0.0f);
                            if (amounts[i]>=0.9999999f)
                            {
                                if (i==1)
                                {
                                    pdir=0;
                                    px=65;
                                }
                                
                                for (int j=0;j<4;j++)
                                {
                                    damounts[j]+=0.00015f;
                                }
                                
                                engagedwith=-1;
                                if (numnonnoisy<2)
                                    
                                afteractiontimer=4;
                            }
                        }
                    }
                    
                }
                
                if (endtimer>0)
                {
                    endtimer--;
                    if (endtimer==0)
                    {
                        quit=true;
                    }
                    return;
                }

                if ((engagedwith==-1)&&canmove&&(!(key[KEY_LEFT]&&key[KEY_RIGHT])))
                {
                    if (key[KEY_LEFT])
                    {
                        pdir=0;
                        px=max(px-1,MIN_X);
                    }
                    if (key[KEY_RIGHT])
                    {
                        pdir=1;
                        px=min(px+1,MAX_X);
                    }
                }
            }
            
            bool bActionpressed=false;
            
            if (key[KEY_SPACE]||key[KEY_ENTER])
            {
                if (!spacepressed)
                {
                    spacepressed=true;
                    bActionpressed=true;
                }
            }                
            else
            {
                spacepressed=false;
            }
            
            if (gamestate==GS_Normal && bActionpressed && afteractiontimer==0 && numnonnoisy>1)
            {                
                if (px<=23 && pdir==false && (!noisebar[0]&&nurseconversation<3))
                {
                    if (bDruggedup)
                    {
                        gamestate=GS_Cutscene;
                        curConversationLine=0;
                        curConversation=PopulateConversation(13);
                    }
                    else if (bDepressed)
                    {
                        gamestate=GS_Cutscene;
                        curConversationLine=0;
                        curConversation=PopulateConversation(12);
                    }
                    else
                    {
                        gamestate=GS_Cutscene;
                        curConversationLine=0;
                        curConversation=PopulateConversation(nurseconversation+1);
                        nurseconversation=(nurseconversation+1);
                        talkingToNurse=true;
                    }
                    goto endoflogic;
                }
                else if (px>=53 && px<=71 && (!noisebar[1]))
                {
                    engagedwith=1;
                }
                else if (px>=90 && px<=108 && (!noisebar[2]))
                {
                    engagedwith=2;
                }
                else if (px>=136 && (!noisebar[3]))
                {
                    if (bDepressed&&noisebar[1]&&noisebar[2])
                    {
                        gamestate=GS_PreCutscene;
                        curConversation=PopulateConversation(14);
                        inittimer=2;
                    }
                    else if (hasbeentosleep)
                    {            
                        engagedwith=3;
                    }
                    else
                    {
                        gamestate=GS_Cutscene;
                        curConversationLine=0;                        
//                        inittimer=1;
                        curConversation=PopulateConversation(11);                                            
                        hasbeentosleep=true;
                        goingtosleep=true;
                        goto endoflogic;
                    }
                }
            }
            
            if (gamestate==GS_Cutscene||gamestate==GS_CollapseCutscene||gamestate==GS_FlashBack)
            {
                if (bActionpressed)
                {
                    curConversationLine++;
                    if (curConversationLine==curConversation.size())
                    {
                        switch (gamestate)
                        {
                            case GS_Cutscene:
                            {
                                if (goingtosleep)
                                {   
                                    engagedwith=3;
                                    goingtosleep=false;
                                }
                                
                                gamestate=GS_Normal;
                                inittimer=5;
                            }
                            break;
                            case GS_FlashBack:
                            {
                                gamestate=GS_WaitPostFlashBack;
                                inittimer=30;
                            }
                            break;
                            case GS_CollapseCutscene:
                            {
                                gamestate=GS_PostCollapse;
                                inittimer=4;
                            }
                            default:
                            {
                                gamestate=GS_Normal;
                                inittimer=3;
                            }
                        }
                        
                        if (curconversationnumber==12)
                        {
                            noisebar[0]=true;
                            bDruggedup=true;
                        }
                        
                        afteractiontimer=4;
                        curConversationLine=0;
                        if (talkingToNurse)
                        {                           
                            amounts[0]=1.0f;     
                            talkingToNurse=false;
                        }
                        
                        for (int i=0;i<4;i++)
                        {
                            damounts[i]+=0.0003f;
                        }
                            
                        if (bWetpants)
                        {
                            noisebar[2]=true;
                            bWetpants=false;
                        }  
                        
                        if (engagedwith!=3)
                            engagedwith=-1;
                        
                    }
                }
            }
            
            endoflogic:
			if (key[KEY_ESC])
			{
				if (!escpressed)
				{
					quit=true;
				}
			}
			else escpressed=false;
			
			
		}
		static void draw()
		{
			clear_to_color(buffer, black);
            
            if (gamestate==GS_PreCollapse)
            {
                if (inittimer>21 && inittimer%4==0)
                    return;
                if (inittimer>14 && inittimer%3==0)
                    return;
                if (inittimer>7 && inittimer%2==0)
                    return;     
                if (inittimer<7)
                    return;
            }
            if(gamestate==GS_PostCollapse&&inittimer)
                return;
                
			if (drawbars && gamestate!=GS_FlashBack && gamestate!=GS_PreCollapse&& gamestate!=GS_PostCollapse && gamestate!=GS_CollapseCutscene && gamestate!=GS_WaitPreFlashBack && gamestate!=GS_WaitPostFlashBack)
			{
				blit(bmp_outline, buffer, 0, 0, 0, 0, SCREEN_WIDTH, 14);
				for (int i=0;i<4;i++)
				{
                    if (noisebar[i])
                    {
                        for (int j=0;j<50;j++)
                        {
                            int rx = 40*i+1 + (rand()%(1+27+9));
                            int ry = 2 + (rand()%(1+10));
                            putpixel(buffer, rx,ry,amber);                        
                        }
                    }
                    else
                    {                    
                        if (i==0&&bDepressed)
                        {
                            //nothing
                        }
                        else if (amounts[i]<0.15f && gametimer%2==0)
                        {
                            rectfill(buffer,40*i+10,2,40*i+11+26,3+9,amber);
                            rect(buffer,40*i+11,3,40*i+11+25*amounts[i],3+8,black);						
                        }
                        else
                            rect(buffer,40*i+11,3,40*i+11+25*amounts[i],3+8,amber);
                    }
				}
			}
			
			blit(bmp_outline,buffer,0,14,0,14,SCREEN_WIDTH,61);
			
            if (gamestate==GS_FlashBack||gamestate==GS_WaitPostFlashBack||gamestate==GS_WaitPreFlashBack)
            {
                    if (!(gamestate==GS_WaitPreFlashBack && inittimer>10 && (inittimer%2==0)) &&
                    !(gamestate==GS_WaitPostFlashBack && inittimer<10 && (inittimer%2==0)))
                    {
                        if (flashbacknumber==1)
                        {

                            if (gamestate==GS_FlashBack&& (curConversationLine==2||curConversationLine==3))                
                                DRAWTILE(bar,1,47,53);
                            else
                                DRAWTILE(bar,0,47,53);
                        }
                        
                        
                        else 
                        {
                            DRAWTILE(rooms,bgs[3],2+2*(bmp_w_rooms+1)-bmp_w_rooms/2,30); 
                            DRAWSPR(spritesheet,5,1,145-bmp_w_rooms-20,56);                      
                            DRAWTILE(visitors,1,145-bmp_w_rooms-36,51);                                          
                        }
                    }
            }
            else if (gamestate==GS_CollapseCutscene)
            {
                        {
                            DRAWTILE(rooms,bgs[3],2+2*(bmp_w_rooms+1)-bmp_w_rooms/2,30); 
                            DRAWSPR(spritesheet,5,1,145-bmp_w_rooms-20,56);                      
                            DRAWTILE(visitors,0,145-bmp_w_rooms-40,51);                                          
                            DRAWTILE(visitors,2,145-bmp_w_rooms-55,51);                                          
                        }            
            }
			else if (showbgs)
			{
				rectfill(buffer, 3, 17, 156, 20, amber);
				for (int i=0;i<4;i++)
				{
                    DRAWTILE(rooms,bgs[i],2+i*(bmp_w_rooms+1),30);
                    
                    if (i<3)
						vline(buffer, 1+(i+1)*(bmp_w_rooms+1), 21, 38, amber);
				}
			}

			if (gamestate==GS_FlashBack||gamestate==GS_CollapseCutscene||gamestate==GS_WaitPostFlashBack||gamestate==GS_WaitPreFlashBack)
            {
            }
            else
			if (walkmode)
			{
                if (gamestate==GS_Normal && engagedwith>0)//okay to draw player normally when talking
                {
                    switch(engagedwith)
                    {
                    case 1:                        
                        if (((gametimer/3)%2)==0)
                        {
                            DRAWSPR(spritesheet,3,1,63,57);                             
                        }
                        else
                        {
                            DRAWSPR(spritesheet,4,1,63,57);                                                     
                        }
                    break;
                    case 2://bathroom
                    break;
                    case 3://sleeping
                        DRAWSPR(spritesheet,5,1,145,56);                    
                    break;
                    }
                }
                else if (bWetpants)
                {
                    DRAWSPR(spritesheet,2,pdir,px,58);
                }
                else
                {
                    DRAWSPR(spritesheet,(px/2)%2,pdir,px,58);
                }
			}
			
            if (gamestate==GS_Cutscene||gamestate==GS_CollapseCutscene||gamestate==GS_FlashBack)
            {
            	blit(bmp_outline,buffer,0,75,0,75,SCREEN_WIDTH,45);			
             
                wrapprint(curConversation[curConversationLine].text, 40, 78, 14);
                DRAWTILE(portraits,curConversation[curConversationLine].person,3,78);
            }
            else if (gamestate==GS_Normal && engagedwith==-1 && afteractiontimer==0 && numnonnoisy>1)
            {
                if (px<=23 && pdir==false) 
                {
                    if (!noisebar[0] && nurseconversation<3)
                        textout_centre_ex(buffer, font, "[talk]",80,88,amber,-1);
                }
                else if (px>=53 && px<=71)
                {
                    if (!noisebar[1])
                        textout_centre_ex(buffer, font, "[eat]",80,88,amber,-1);
                }
                else if (px>=90 && px<=108)    
                {            
                    if (!noisebar[2])
                        textout_centre_ex(buffer, font, "[go to toilet]",80,88,amber,-1);
                }
                else if (px>=136)
                {
                    if (!noisebar[3])
                        textout_centre_ex(buffer, font, "[go to bed]",80,88,amber,-1);
                }
/*

nurse: < 23
eat: 53 - 71
bathroom: 90-108
bed: 136
*/
            }
			
		}
	};

template<int i>
class BlackLoop
	{
	public:
		static void initialize()
		{
			escpressed=true;
			bltime=0;
			finishedtitle=false;
            stopmusic();
		}
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		static void logic()
		{
			bltime++;
			if (bltime>i*FRAMERATE)
			{
				finishedtitle=true;
			}


			if (key[KEY_ESC]&&!escpressed)
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];

		}
		static void draw()
		{
			clear_to_color(buffer, bgcol);
		}
	};


template<class T> void loop();



int storyprogress;
bool finishedstory;



class IntroLoop
	{
	public:
		static void initialize()
		{
			spacepressed=true;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{
			titletimer++;

			if (titletimer>20||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}

		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_ex(buffer, font, "increpare presents", 7, 45,amber, -1);

		}
	};


class IntroDialogue
	{
	public:
		static void initialize()
		{
			spacepressed=true;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
			quit=false;
		}
		
		static bool quitcondition()
		{
			return quit||finishedtitle;
		}
		
		static void logic()
		{
			titletimer++;
			
			if (titletimer>120||(mouse_b&1)||keypressed())
			{
				position_mouse(400,200);
				finishedtitle=true;
			}
		}
		
		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_centre_ex(buffer, font, "increpare presents", 40, 10,white, -1);
			
		}
	};


class GameOverLoop
	{
	public:
		static void initialize()
		{

			spacepressed=true;
			quit=false;
			escpressed=true;
			speed_count=0;
			titletimer=0;
			finishedtitle=false;
		}

		static bool quitcondition()
		{
			return quit||finishedtitle;
		}

		static void logic()
		{


			if ((key[KEY_ESC]&&!escpressed)||key[KEY_SPACE])
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];

		}

		static void draw()
		{
		    clear_to_color(buffer,bgcol);
			textout_centre_ex(buffer, font, "and you won", 160, 4*10,white, -1);
			textout_centre_ex(buffer, font, "and nothing will be the same again", 160, 5*10,white, -1);
		}
	};


class TitleLoop
	{
	public:
		static bool begin;
		static unsigned int selected;
		static bool upheld;
		static bool downheld;
		static bool spaceheld;
	public:
		static void initialize()
		{
			levelseed=1;
			spacepressed=true;
			endmode=false;
			endmenutimer=0;
			quit=false;
			begin=false;
			selected=0;
			upheld=true;
			downheld=true;
			spaceheld=true;
			escpressed=true;
			playmusic(1);

		}

		static void logic()
		{

			if (endmenutimer>0)
			{
				endmenutimer--;


				return;
			}

			if (key[KEY_ESC]&&!escpressed)
			{
				quit=true;
			}
			escpressed=key[KEY_ESC];



			if (key[KEY_UP])
			{
				if (!upheld)
				{
					playsample();
					selected=(selected+1)%2;
					upheld=true;
				}
			}
			else
				upheld=false;

			if (key[KEY_DOWN])
			{
				if (!downheld)
				{
					playsample();
					selected=(selected+1)%2;
					downheld=true;
				}
			}
			else
				downheld=false;

			if (key[KEY_SPACE])
			{
				if (!spaceheld)
				{
					if (selected==0)
					{
						playsample();
						begin=true;
						endmenutimer=10;
					}
					else
					{
						playsample();
						quit=true;
						endmenutimer=10;
					}
				}
			}
			else
				spaceheld=false;

		}

		static bool quitcondition()
		{
			return (quit||begin) && endmenutimer==0;
		}

		static void draw()
		{
			DRAWTILE(title,0,0,0);

			if ( (endmenutimer>0 && endmenutimer<2))
			{
				return;
			}


			if (selected==0)
			{
				if ((endmenutimer)%2==0)
				{
					rectfill(buffer, 105, 30, 156, 40, amber);
					textout_ex(buffer,font,"Start",110,32,bgcol,amber);
				}
				textout_ex(buffer,font,"Exit",110,50,amber,-1);
			}
			else
			{
				textout_ex(buffer,font,"Start",110,32,amber,-1);

				if ((endmenutimer)%2==0)
				{
					rectfill(buffer, 105, 48, 156, 58, amber);
				textout_ex(buffer,font,"Exit",110,50,bgcol,amber);
				}
			}

		}

	};

bool TitleLoop::begin=false;
unsigned int TitleLoop::selected=0;
bool TitleLoop::upheld=false;
bool TitleLoop::downheld=false;
bool TitleLoop::spaceheld=true;





template<class T>
void loop()
{

	clear_to_color(buffer, bgcol);

	T::initialize();

	while(!T::quitcondition())
	{
		al_poll_duh(dplay);

		while(speed_count>0)
		{
			poll_mouse();

			//			if (key[KEY_ESC])
			//				quit=true;

			T::logic();

			speed_count--;
			
			T::draw();

			for (int i=0;i<filteramount;i++)
			{
				int x1 = 1+(rand()%(SCREEN_WIDTH-2));
				int y1 = 1+(rand()%(SCREEN_HEIGHT-2));
				int x2 = x1 + (rand()%2)*2 -1;
				int y2 = y1 + (rand()%2)*2 -1;
				putpixel(buffer, x2, y2, getpixel(buffer, x1, y1));
			}
			
            acquire_bitmap(screen);
			stretch_blit(buffer, screen, 0, 0, SCREEN_WIDTH, SCREEN_HEIGHT, 0, 0, 640, 480);
			
			for (int i=0;i<filteramount;i++)
			{
				int x1 = 1+(rand()%(640-2));
				int y1 = 1+(rand()%(480-2));
				int x2 = x1 + (rand()%2)*2 -1;
				int y2 = y1 + (rand()%2)*2 -1;
				putpixel(screen, x2, y2, getpixel(screen, x1, y1));
			}
            release_bitmap(screen);
			
		}
		rest(100 / FRAMERATE);//rest until a full tick has passed
		
		}
}



void init(int argc, char *argv[])
{

	/* initialise everything */
	allegro_init();
 
	init_sound(argc,argv);

	set_color_depth(32);

	install_keyboard();
	install_mouse();
	install_timer();


	#ifdef __APPLE__
	CGDisplayHideCursor(kCGDirectMainDisplay);
	#endif

	set_alpha_blender();

    LOCK_VARIABLE(speed_counter); //Used to set the timer - which regulates the game's
    LOCK_FUNCTION(increment_speed_counter);//speed.
    install_int_ex(increment_speed_counter, BPS_TO_TIMER(FRAMERATE));

	set_gfx_mode(GFX_AUTODETECT_FULLSCREEN, 640, 480, 0, 0) ;

	red=makecol(255,0,0);
	lightred=makecol(255,200,200);
	magenta=makecol(255,0,255);
	black=makecol(0,0,0);
	white=makecol(255,255,255);
	blue=makecol(0,0,255);
	bgcol=makecol(0,0,0);
	yellow=makecol(255,255,0);
	green=makecol(0,255,0);
	lightgreen=makecol(200,255,200);
	grey=makecol(100,100,100);
	lightgrey=makecol(200,200,200);
	orange=makecol(253,183,58);
	purp0=makecol(107,30,98);
	purp1=makecol(199,40,162);
	purp2=makecol(255,220,255);
	amber=makecol(213,140,37);

	//load save data


	//init the buffer
	buffer=create_bitmap(SCREEN_WIDTH, SCREEN_HEIGHT);
	LOADBMP(bar)
	LOADBMP(outline)
	LOADBMP(icons)
	LOADBMP(portraits)
	LOADBMP(rooms)
	LOADBMP(spritesheet)
	LOADBMP(title)
	LOADBMP(visitors)
	
}

int dir;

bool gototitle=false;


int main(int argc, char *argv[])
{
	
	
	
	
	init(argc,argv);


	loop<IntroLoop>();

titletag:
	gototitle=false;

	loop<TitleLoop>();

	if (quit)
		goto end;
    
    loop<BlackLoop<1> >();

	if (quit)
	{
		gototitle=true;
		goto menuskip;
	}

	loop<LevelLoop >();



menuskip:
    loop<BlackLoop<3> >();
	quit=false;
	finishedtitle=false;
	TitleLoop::begin=false;
	goto titletag;

end:
	quit=false;
	stop_sound();
	return 0;

}
END_OF_MAIN()
